#include <fcntl.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "resource.h"
#include "serverrequest.h"
#include "strings.h"

/* In welchem Vezeichniss befinden sich die zu ausliefernden Dateien? */
static char docroot[1000] = "wwwdocs";

/* Datei fr HTTP-Response liefern */
int returnfile(int conn, int resource, struct ReqInfo * reqinfo) {
	int *buffer = (int*) malloc(BUFFER_WRITE);
    int  i;

    while ((i = read(resource, buffer, BUFFER_WRITE))) {
		if (i < 0)
			quit_error(E_RESOURCE_READ);
		if (write(conn, buffer, BUFFER_WRITE) < 1)
			quit_error(E_RESOURCE_WRITE);
	}
	
	free(buffer);

    return 0;
}


/* Datei ffnen/berprfen */
int checkfile(struct ReqInfo * reqinfo) {
	char * file = reqinfo->resource;

	/* URL-Encoded Strings bereinigen */
    translate_url(file);
	
	/* Wenn nach dem docroot gefragt wird, ihn durch /index.html ersetzen */
	if(strcmp(file, "/") == 0) {
		file = "/index.html";
	}
	
    strcat(docroot, file);
    return open(docroot, O_RDONLY);
}


/*  HTTP-Fehlermeldung fr Status 400 und 401 */

int returnerror(int conn, struct ReqInfo * reqinfo) {
    char buffer[100];
    sprintf(buffer, "<html>\n<head>\n<title>Server Error %d</title>\n"
	            "</head>\n\n", reqinfo->status);
    socket_writeline(conn, buffer, strlen(buffer));

    sprintf(buffer, "<body>\n<h1>Server Error %d</h1>\n", reqinfo->status);
    socket_writeline(conn, buffer, strlen(buffer));

    sprintf(buffer, "<p>Sorry, your request could not be served.</p>\n"
	            "</body>\n</html>\n");
    socket_writeline(conn, buffer, strlen(buffer));

    return 0;

}
