#ifndef UHTTPSSTRINGS_H
#define UHTTPSSTRINGS_H

#include <unistd.h>

/* Server Konfiguration */

/* Listening Port des Servers */
#define SERVER_PORT         (8080)
/* Lesebuffer des Servers */
#define BUFFER_READ			(2048)
/* Schreibbuffer des Servers */
#define BUFFER_WRITE		(8192)
/* Maximale Gre EINER ZEILE innerhalb einer Request */
#define REQSIZE				(512)


/* Strings */
#define N_WELCOME			"uhttps 0.1.0"
#define N_SERVER_READY		"Server ist bereit und wartet auf Verbindungen."
#define E_RESOURCE_RETURN	"Datei konnte nicht ausgeliefert werden."
#define E_RESOURCE_CLOSE	"Datei konnte nicht ausgeliefert werden."
#define E_RESOURCE_READ		"Datei konnte nicht ausgeliefert werden."
#define E_RESOURCE_WRITE	"Datei konnte nicht ausgeliefert werden."
#define E_SOCKET_CREATE		"Socket konnte nicht erstellt werden."
#define E_SOCKET_BIND		"Socket konnte nicht an Adresse gebunden werden."
#define E_SOCKET_SERVER		"Server konnte nicht auf Socket lauschen."
#define E_SOCKET_ACCEPT		"Server konnte die Verbindung nicht annehmen."
#define E_SOCKET_CHILD		"Server konnte die Verbindung nicht verarbeiten."
#define E_SOCKET_CLOSE		"Server konnte die Verbindung nicht trennen."
#define E_SOCKET_REQUEST	"Server konnte die Anfrage des Clients nicht verstehen."
#define E_SOCKET_READ		"Server konnte Daten nicht auslesen."
#define E_SOCKET_WRITE		"Server konnte Daten nicht verschicken."

int     trim				(char * buffer);
int     strupper 			(char * buffer);
void    translate_url		(char * buffer);
void    quit_error			(char const * msg);
void    notice				(char const * msg);
ssize_t socket_readline 	(int sockd, void *vptr, size_t maxlen);
ssize_t socket_writeline	(int sockd, const void *vptr, size_t n);


#endif  /* UHTTPSSTRINGS_H */
