#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "serverrequest.h"
#include "strings.h"

/* main() Funktion */
int main(int argc, char *argv[]) {
	int    listener, connection;
    pid_t  pid;
    struct sockaddr_in servaddr;

    notice(N_WELCOME);
	
    /* Socket erstellen */
    if ((listener = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	quit_error(E_SOCKET_CREATE);


    /* Socket Adressstruktur bereitstellen */
    memset(&servaddr, 0, sizeof(servaddr));
    servaddr.sin_family      = AF_INET;
    servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
    servaddr.sin_port        = htons(SERVER_PORT);


    /* Socket an Adresse binden */ 
    if (bind(listener,(struct sockaddr *) &servaddr, sizeof(servaddr)) < 0 )
	quit_error(E_SOCKET_BIND);

    /* Auf Socket lauschen */
    if (listen(listener, BUFFER_READ) < 0 )
	quit_error(E_SOCKET_SERVER);

	notice(N_SERVER_READY);

    /* Endlosschleife: Akzeptieren von Verbindungen */
    while ( 1 ) {
		/* Auf eine Verbindung warten */
		if ((connection = accept(listener, NULL, NULL)) < 0 )
	    quit_error(E_SOCKET_ACCEPT);

		/* Kindprozess erstellen um die neue Verbindung zu verarbeiten */
		if ((pid = fork()) == 0 ) {
			/* Dieser Prozess ist jetzt der Kindprozess, wir mssen daher den Listening-Socket schlieen */
			if (close(listener) < 0 )
			quit_error(E_SOCKET_CHILD);
			
			/* Clientanfrage verarbeiten */
			serverrequest(connection);

			/* Verbindung trennen */
			if ( close(connection) < 0 )
			quit_error(E_SOCKET_CLOSE);
			
			/* Kindprozess beenden */
			exit(EXIT_SUCCESS);
		}

		/* Hier beginnt wieder der Elternprozess */
		
		/* Verbindungen des Kindprozesses trennen */
		if (close(connection) < 0)
			quit_error("Error closing connectionection socket in parent.");

		/* Aufrumen */
		waitpid(-1, NULL, WNOHANG);
    }

	
	/* Dieser Punkt drfte nicht erreicht werden */
    return EXIT_FAILURE;
}
